# stop the ceph-rgw daemon on all hosts as the command needs the cluster status to be in HEALTH_OK
function upgrade_rgws () {
for host in $(ceph node ls| jq -r '.osd|keys|join(" ")')
 do
  ssh $host 'systemctl stop ceph-radosgw.target && rm -rf /var/lib/ceph/radosgw/ceph-*'
 done
 echo "sleeping 20 seconds to allow for old rgw instances to stop"
 sleep 20
 ceph orch apply rgw site1 zone1 --placement="3 $(ceph node ls|jq -r '.mon|keys| join(" ")')" --port=8080
 while [[ $(ceph health) != "HEALTH_OK" ]]
  do
   echo "sleeping 5 seconds before next check"
   sleep 5
  done
echo "Setting default realm"
radosgw-admin realm default --rgw-realm=site1
}
# we may have to adjust this for fresh installs as per https://docs.ceph.com/en/latest/mgr/orchestrator/
