<h2 id="storage-node-upgrade">Upgrade Storage Node Steps</h2>

These steps should be run for a storage node after the common upgrade steps are complete.

1. Create a partition for the `/var/lib/ceph` directory.

   > **`NOTE`:** This step will go away when MTL-1308 is addressed.

   ```bash
   ncn# parted /dev/sda mkpart ext4 401GB 420G
   ncn# mkfs.ext4 /dev/sda4
   ncn# mount /dev/sda4 /var/lib/ceph
   ncn# chown -R ceph:ceph /var/lib/ceph
   ```

2. Restore the `/var/lib/ceph` and `/etc/ceph` directories.

   > **`NOTE`:** This step will go away when MTL-1308 is addressed.

   - Copy the file from the $STABLE_NCN (execute from the stable ncn node):

   ```bash
   ncn# scp /tmp/$(UPGRADE_NCN)-ceph.tgz $UPGRADE_NCN:/ 
   ```
   - Restore the directories -- run this command on the newly upgraded storage node:

   ```bash
   ncn# tar -xvf /tmp/$(hostname)-ceph.tgz -C /
   ```

3. Watch the status of the cluster.  Run this command from a separate terminal window on the stable ncn:

   ```bash
   watch "ceph orch ps | grep $UPGRADE_NCN; echo ''; ceph osd tree"
   ```

4. Restore the /etc/ceph directory

   For nodes running ceph-mon (typically ncn-s001/2/3)

   ```bash
   scp <ncn-s00(1/2/3)>:/etc/ceph/* .
   ```

   For all other ceph-nodes

   ```bash
   scp <older version active non ceph-mon node>:/etc/ceph/* .
   ```

5. Grab the ceph ssh key

   ```bash
   ceph cephadm get-pub-key > ~/ceph.pub
   ```

6. Add the ceph public key to the upgraded node -- run this command from the stable node.

   ```bash
   ncn# ssh-copy-id -f -i ~/ceph.pub root@$UPGRADE_NCN
   ```

7. Add the host back into the ceph cluster.  Run this command from the stable ncn.

   ```bash
   ncn# ceph orch host add $UPGRADE_NCN
   ```

8. Start the osds on the newly upgraded node.  This command should be run on the newly upgraded storage node:

   ```bash
   ncn# for osd in $(ls -d /var/lib/ceph/*/osd*); do source $osd/unit.run; done
   ```

9.  Start the `mon` daemon.  This command can be run from the stable node.

   ```bash
   ncn# ceph orch redeploy mon
   ```

11. Start the remainder of the daemons. This command should be run on the newly upgraded storage node:

   ```bash
   ncn#  for s in $(ceph orch ps | grep $UPGRADE_NCN | awk '{print $1}'); do  ceph orch daemon start $s; done
   ```

10. fix apparmor/ generate haproxy cfg / generate keepalived config


11. Proceed either of the following options:

   - [Back to Common Prerequisite Steps](../common/prerequisite-steps.md) to rebuild another storage node
   - [Back to Main Page](../../README.md) if done upgrading storage nodes
